const socksv5 = require('socksv5')
const shell = require('shelljs')
let authUserList = []

const PORT = 3000
const server = socksv5.createServer((_, resolve) => resolve())


server.listen(PORT, () => console.log(`Listen: localhost:${PORT}`))
server.useAuth(socksv5.auth.UserPassword((username, password, cb) => {
isAuthUser(username,password,cb)
}))

async function isAuthUser(user, pass, cb) {

    let cashedUser = await isUserFoundInCashe(user, pass, cb)
    if (cashedUser) {
        cb(true)
        return true
    }

    let isRadiusUser = await radius(user, pass)
    if (isRadiusUser) {
        cb(true)
        authUserList.push({user: user, pass: pass})
        return true
    }

    cb(false)


}

async function radius(user, pass) {
    let a = await shell.exec('radtest ' + user + ' ' + pass + ' ' + '54.38.189.114 0 testing123', {silent: true}).stdout;
    return a.includes("Access-Request") === true
}


async function isUserFoundInCashe(user, pass) {
    for (let i = 0; i < authUserList.length; i++) {
        if (authUserList[i].user === user && authUserList[i].pass === pass)
            return true
    }

    return false
}
